<?php
/**
 * @author Bryan Jayson Tan <admin@bryantan.info>.
 * @link http://bryantan.info
 * @link http://snapshop.ph
 * @date 11/27/12
 * @time 1:03 PM
 */
class JwplayerColumn extends CDataColumn 
{
   
    public $skin='bekle';
    public $file=null;
    public $image=null;
    public $flashplayer=null;
    public $width=300;
    public $height=180;
    public $options=array();
    public $tag='div';
    private $_assetsUrl=null;

    /**
     * init widget
     */
    public function init(){
        $this->registerAssets();
       
        if ($this->file===null){
            $this->options['file']=$this->_assetsUrl.'/video.mp4';
        } else {
            $this->options['file'] = $this->file;
        }
        if ($this->file===null && $this->image===null){
            $this->options['image']=$this->_assetsUrl.'/preview.jpg';
        } else {
            $this->options['image'] = $this->image;
        }
        if ($this->flashplayer===null){
            $this->options['flashplayer']=$this->_assetsUrl.'/player.swf';
        }
        $this->options['width']=$this->width;
        $this->options['height']=$this->height;
        $this->options['skin']=  $this->skin;
         $this->options['x']=  0;
        Yii::app()->getClientScript()->registerScriptFile($this->_assetsUrl.'/jwplayer.js');
    }

  

    /**
     * register assets
     * @return mixed
     */
    public function registerAssets(){
        if ($this->_assetsUrl===null){
            $assetsUrl = Yii::app()->assetManager->publish(dirname(__FILE__).'/assets');
            return $this->_assetsUrl = $assetsUrl;
        }
    }
     
    
      protected function renderDataCellContent($row, $data) {
           $id= $row++; // for random key support
           echo CHtml::tag($this->tag,array('id'=>$id));
           echo CHtml::closeTag($this->tag);
           $options = CJavaScript::encode($this->options);
           Yii::app()->getClientScript()->registerScript('jwplayer'.$id, "jwplayer('{$id}').setup({$options})");
          
          }
 
}
